import * as _codemirror_state from '@codemirror/state';
import { Extension, EditorStateConfig, EditorState } from '@codemirror/state';
import { ViewUpdate, EditorView, EditorViewConfig } from '@codemirror/view';

declare const _default: _codemirror_state.Extension[];

interface EventCallbacks {
    onChange?(doc: string, viewUpdate: ViewUpdate): void;
    onChangeInterval?: number;
    onUpdate?(viewUpdate: ViewUpdate): void;
    onFocus?(viewUpdate: ViewUpdate): void;
    onBlur?(viewUpdate: ViewUpdate): void;
    onPaste?(event: ClipboardEvent, view: EditorView): void;
}
declare function eventsToExtensions({ onChange, onFocus, onBlur, onPaste, onChangeInterval }?: EventCallbacks): Extension[];

interface StateConfig extends EditorStateConfig {
    events?: EventCallbacks;
}
declare function createState({ events, ...state }?: StateConfig): EditorState;
declare function createEditor({ state, ...config }?: EditorViewConfig): EditorView;

export { type EventCallbacks, type StateConfig, createEditor, createState, eventsToExtensions, _default as extensions };
